<template>
  <div class="block">
    <h3 class="">
        Edition Form
    </h3>
    <Input 
      label="Name"
      inputType="text"
      model="editionName"
    />

    <Input
        label="Date"
        input-type="date"
        model="editionDate"
    />

    <Input
        label="Subscriptions"
        input-type="date"
        model="subscriptions"
    />

    <Input
        label="Theme"
        input-type="text"
        model="theme"
    />

    <Input
        label="Description"
        input-type="text"
        model="description"
    />

    <Input
        label="Rules (é um vetor)"
        input-type="text"
        model="rules" 
    />

    <Input
        label="Pre Requirements (vetor)"
        input-type="text"
        model="preRequirement"
    />

    <Input
        label="Location"
        input-type="text"
        model="location"
    />

    <div class="flex">
        <Input
            label="Judging Criteria: Name"
            input-type="text"
            model="nameAux"
        />
        <Input
            label="Judging Criteria: Description"
            input-type="text"
            model="descriptionAux"
        />
        <Button :action="addJudgingCriteria" text="Add" buttonType="primaryAlt"/>
    </div>

    <div class="flex" v-for="(j, index) in judgingCriteria" :key="j.name">
        {{j.name}}: {{j.description}}
        <Toogle label="" model="toggleAux"/>
        <!-- <Button :action="delJudgingCriteria(index)" text="X"/> -->
    </div>

    <router-link to="/h/hackathon/ed">
      <Button :action="saveEdition" text="Save" buttonType="primaryAlt"/>
    </router-link>
    <router-view />
  </div>
</template>

<script lang="ts">
import Vue from 'vue';

import NavBar from '@/components/Navbar.vue';
import Input from '@/components/Base/Input.vue';
import Button from '@/components/Base/Button.vue';

interface Judging {
    name: string,
    description: string,
}

interface EditionData {
    editionName: string;
    editionDate: Date,
    subscriptions: Date,
    theme: string,
    description: string,
    rules: string,
    preRequirement: string,
    location: string,
    judgingCriteria: Judging[],
}

export default Vue.extend({
  data() {
    return {
      editionName: '',
      editionDate: {} as Date,
      subscriptions: {} as Date,
      theme: '',
      description: '',
      rules: '',
      preRequirement: '',
      location: '',
      judgingCriteria: [] as Judging[],
      nameAux: '',
      descriptionAux: '',
      toogleAux: true,
    };
  },
  components: {
    NavBar,
    Input,
    Button,
  },
  methods: {
    saveEdition() {
        console.log(this.editionName + ' ' + this.editionDate + ' ' + this.subscriptions);
    },
    addJudgingCriteria() {
        this.judgingCriteria.push({name: this.nameAux, description: this.descriptionAux});
    },
    delJudgingCriteria(index: any) {
        this.judgingCriteria.splice(index, 1);
    },
  },
});
</script>
